
Global $filename

$fod = FileOpenDialog ("title", @ScriptDir, "All (*.*)")
$fo = FileOpen ($fod, 128)
$fr = FileRead ($fo)
$fow = FileOpen ($fod & "_.txt", 129)
; $fow = FileOpen ("result", 129)

FileWrite ($fow, "File Name" & @TAB & "Segment Number" & @TAB & "Source Text" & @TAB & "Machine Suggestion" & @TAB & "Original Target" & @TAB & "Revised Target" & @TAB & "QA Comment" & @CRLF)

; get bottom part (with the segments in it)

$bottompartsplit = StringSplit ($fr, '<div class="document-name top-10" style="box-sizing: inherit; margin-top: 10px !important;">FILE<span>', 1)
$bottompart = $bottompartsplit[2]

; get file name

$filenamesplit = StringSplit ($bottompartsplit[2], '</div>', 1)
$filename = $filenamesplit[1]
$filename = StringReplace ($filename, ' </span>', '')
$filename = StringReplace ($filename, '</span>', '')

; fix DIVS etc.

$bottompart = StringRegExpReplace ($bottompart, '(<div class="segment-id".+?>)', "asdfSEGMENTIDasdf")
$bottompart = StringRegExpReplace ($bottompart, '(<div class="segment-content qr-text".+?>)', "asdfSEGMENTCONTENTQRTEXTasdf")

; split by segment

$segmentsplit = StringSplit ($bottompart, 'asdfSEGMENTIDasdf', 1)


For $i = 2 to $segmentsplit[0] ; 2 because we ignore the first part

; get segment number

$segnumsplit = StringSplit ($segmentsplit[$i], '</div>', 1)
$segnum = $segnumsplit[1]


; get source text

$sourcesplit1 = StringSplit ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder;">Source</b>', 1)
$sourcesplit2 = StringSplit ($sourcesplit1[2], '<b style="box-sizing: inherit; font-weight: bolder;">Suggestion</b>', 1)
$rawsource = $sourcesplit2[1]

$sourcesplit3 = StringSplit ($rawsource, 'asdfSEGMENTCONTENTQRTEXTasdf', 1)
$sourcesplit4 = StringSplit ($sourcesplit3[2], '</div>', 1)
$finalsource = $sourcesplit4[1]

; we assume that all SPANs are tags (except in the revised translation)
; then convert tags:
$finalsource = StringReplace ($finalsource, '<span> </span>', ' ')
$finalsource = StringRegExpReplace ($finalsource, '(<span.+?>)(.+?)(</span>)', "①$2②")


; get MT match (Matecat calls it the "Suggestion")

$mtmatchsplit1 = StringSplit ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder;">Suggestion</b>', 1)
$mtmatchsplit2 = StringSplit ($mtmatchsplit1[2], '<b style="box-sizing: inherit; font-weight: bolder; color: rgb(0, 153, 204); text-decoration: underline; cursor: pointer;">Translation</b>', 1)
$rawmtmatch = $mtmatchsplit2[1]

$mtmatchsplit3 = StringSplit ($rawmtmatch, 'asdfSEGMENTCONTENTQRTEXTasdf', 1)
$mtmatchsplit4 = StringSplit ($mtmatchsplit3[2], '</div>', 1)
$finalmtmatch = $mtmatchsplit4[1]

; then convert tags:
$finalmtmatch = StringReplace ($finalmtmatch, '<span> </span>', ' ')
$finalmtmatch = StringRegExpReplace ($finalmtmatch, '(<span.+?>)(.+?)(</span>)', "①$2②")


; get original translation

If StringInStr ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder; color: rgb(0, 153, 204); text-decoration: underline; cursor: pointer;">Translation</b>') Then

$origtargetsplit1 = StringSplit ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder; color: rgb(0, 153, 204); text-decoration: underline; cursor: pointer;">Translation</b>', 1)
$origtargetsplit2 = StringSplit ($origtargetsplit1[2], '<b style="box-sizing: inherit; font-weight: bolder; color: rgb(47, 177, 119); text-decoration: underline; cursor: pointer;">Revision</b>', 1)
$raworigtarget = $origtargetsplit2[1]

$origtargetsplit3 = StringSplit ($raworigtarget, 'asdfSEGMENTCONTENTQRTEXTasdf', 1)
$origtargetsplit4 = StringSplit ($origtargetsplit3[2], '</div>', 1)
$finalorigtarget = $origtargetsplit4[1]

; then convert tags:
$finalorigtarget = StringReplace ($finalorigtarget, '<span> </span>', ' ')
$finalorigtarget = StringRegExpReplace ($finalorigtarget, '(<span.+?>)(.+?)(</span>)', "①$2②")
Else
$finalorigtarget = '(no original translation)'
EndIf


; get revised translation

If StringInStr ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder; color: rgb(47, 177, 119); text-decoration: underline; cursor: pointer;">Revision</b>') Then

$revtargetsplit1 = StringSplit ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder; color: rgb(47, 177, 119); text-decoration: underline; cursor: pointer;">Revision</b>', 1)

If StringInStr ($revtargetsplit1[2], '<b style="box-sizing: inherit; font-weight: bolder;">QA</b>') Then
$revtargetsplit2 = StringSplit ($revtargetsplit1[2], '<b style="box-sizing: inherit; font-weight: bolder;">QA</b>', 1)
$rawrevtarget = $revtargetsplit2[1]
Else
$rawrevtarget = $revtargetsplit1[2]
EndIf

$revtargetsplit3 = StringSplit ($rawrevtarget, 'asdfSEGMENTCONTENTQRTEXTasdf', 1)
$revtargetsplit4 = StringSplit ($revtargetsplit3[2], '</div>', 1)
$finalrevtarget = $revtargetsplit4[1]

; we have to undo the tracked changes:
$finalrevtarget = StringRegExpReplace ($finalrevtarget, '(<span class="deleted".+?>)(.+?)(</span>)', "")
$finalrevtarget = StringRegExpReplace ($finalrevtarget, '(<span class="added".+?>)(.+?)(</span>)', "$2")

; then convert tags:
$finalrevtarget = StringReplace ($finalrevtarget, '<span> </span>', ' ')
$finalrevtarget = StringRegExpReplace ($finalrevtarget, '(<span.+?>)(.+?)(</span>)', "①$2②")

Else
$finalrevtarget = '(no revised translation)'
EndIf

; get qa comments

If StringInStr ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder;">QA</b>') Then
$qacommentsplit1 = StringSplit ($segmentsplit[$i], '<b style="box-sizing: inherit; font-weight: bolder;">QA</b>', 1)
$rawqacomment = $qacommentsplit1[2]
Else
$rawqacomment = '(no qa comments)'
EndIf


$finalqacomment = StringRegExpReplace ($rawqacomment, '(<.+?>)', "|")
$finalqacomment = StringReplace ($finalqacomment, '| |', '|')
$finalqacomment = StringReplace ($finalqacomment, '||||', '|')
$finalqacomment = StringReplace ($finalqacomment, '|||', '|')
$finalqacomment = StringReplace ($finalqacomment, '||', '|')

$finalqacomment = StringReplace ($finalqacomment, @CRLF & '|' & @CRLF & '|', '')

; FileWrite ($fow, $filename & @TAB & $segnum & @TAB & $rawsource & @TAB & $rawmtmatch & @TAB & $raworigtarget & @TAB & $rawrevtarget & @TAB & $rawqacomment & @CRLF)

FileWrite ($fow, $filename & @TAB & $segnum & @TAB & $finalsource & @TAB & $finalmtmatch & @TAB & $finalorigtarget & @TAB & $finalrevtarget & @TAB & $finalqacomment & @CRLF)

Next

#cs

; Convert tags

$fr = StringRegExpReplace ($fr, '(<input.+?)(tfull=")(.+?)(".+?>.+?>.+?>)', "{{{$3}}}")

; Get source and target text

$frfortext = $frseg[$i]

$frtext1 = StringRegExp ($frfortext, '(<pre.+?>)(.+?)(</pre>)', 1)
$frfortext = StringRegExpReplace ($frfortext, '(<pre.+?>)(.+?)(</pre>)', '###', 1)
$frtext2 = StringRegExp ($frfortext, '(<pre.+?>)(.+?)(</pre>)', 1)

$sourcetext = $frtext1[1]
$targettext = $frtext2[1]

Local $replacement[5][2] = [["&quot;", '"'] _
, ["&lt;", '<'] _
, ["&gt;", '>'] _
, ["&apos;", "'"] _
, ["&amp;", '&']]
For $replacementloop = 0 to UBound($replacement) - 1
$sourcetext = StringReplace ($sourcetext, $replacement[$replacementloop][0], $replacement[$replacementloop][1])
$targettext = StringReplace ($targettext, $replacement[$replacementloop][0], $replacement[$replacementloop][1])
Next

#ce
